"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withSubs = void 0;

var _react = _interopRequireWildcard(require("react"));

var _client = require("./client/client");

var _transforms = require("./transforms");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * Higher Order Component to add a subscription to a component
 * @func
 * @static
 * @param {object} settings Settings
 * @param {string} settings.propName Prop name in wrapped component to send data for
 * @param {array} settings.channels Channel spec with rid & path
 * @param {func} settings.transform Possible transform of each resulting data point
 * @param {any} settings.init Initial value
 * @param {array} settings.lengths A "guess" of each channel's space in resulting pl
 * @returns {Component} A new component
 */
var withSubs = function withSubs(settings) {
  // settings: { myKey: { init: x, rid:'<aRid>'} }
  // const dataKey = R.o(R.head, R.keys)(settings);
  var _settings$propName = settings.propName,
      propName = _settings$propName === void 0 ? 'point' : _settings$propName,
      _settings$historyProp = settings.historyPropName,
      historyPropName = _settings$historyProp === void 0 ? 'points' : _settings$historyProp,
      channels = settings.channels,
      transform = settings.transform,
      init = settings.init,
      _settings$ttl = settings.ttl,
      ttl = _settings$ttl === void 0 ? 84600 : _settings$ttl,
      rest = _objectWithoutProperties(settings, ["propName", "historyPropName", "channels", "transform", "init", "ttl"]);

  var doTransform = transform && typeof transform === 'function';
  return function (Component) {
    var WithSubs = function WithSubs(props) {
      // console.log('WithSubs render:', propName, channels, init, rest);
      var unsubscribes = (0, _react.useRef)([]);

      var _useState = (0, _react.useState)(init),
          _useState2 = _slicedToArray(_useState, 2),
          point = _useState2[0],
          setPoint = _useState2[1];

      var _useState3 = (0, _react.useState)([]),
          _useState4 = _slicedToArray(_useState3, 2),
          points = _useState4[0],
          setPoints = _useState4[1];

      var setter = (0, _react.useCallback)(function (msg) {
        // console.log('WithSub setter:', doTransform, typeof channel.transform, msg);
        setPoint(function (prevData) {
          return doTransform ? transform(msg, prevData) : msg;
        });
      }, [setPoint]);
      (0, _react.useEffect)(function () {
        // console.log('WithSub init-effect:', channels);
        if (!channels || channels.some((0, _transforms.hasnt)('rid'))) return undefined; // console.log('WithSub will run fromChannels with:', channels, rest);

        (0, _client.fromChannels)(_objectSpread({
          channels: channels,
          ttl: ttl
        }, rest, {
          // ttl, from, lengths
          cb: setter,
          historyCb: setPoints
        })).then(function (unsubs) {
          return unsubscribes.current = unsubs;
        });
        return function () {
          return unsubscribes.current.forEach(function (f) {
            return f();
          });
        };
      }, []);
      return _react["default"].createElement(Component, _extends({
        ttl: ttl
      }, props, _defineProperty({}, propName, point), _defineProperty({}, historyPropName, points)));
    };

    return WithSubs;
  };
};

exports.withSubs = withSubs;